#include "animhandler.h"
#include "QString"
#include "QThread"

void AnimHandler::start_slot()
{
    nextmode = Mode::RUN;
}
void AnimHandler::pause()
{
    nextmode = Mode::PAUSE;
}
void AnimHandler::stop()
{
    nextmode = Mode::STOP;
}
void AnimHandler::enableExit()
{
    exitThread = true;
}

void AnimHandler::run() {
    qDebug() << "STARTED BITCHES";
    int cnt = 0;
    int curframelen = 0;
    while (!exitThread) {
        if (nextmode != mode)
        {
            mode = nextmode;
            switch (mode) {
            case STOP:
                cnt = 0;
                anim.seek(0);
                emit progressUpdate(0);
                qDebug() << "Stopped";
                emit onStopped(); break;
            case RUN:
                qDebug() << "Run";
                emit onStarted(); break;
            case PAUSE:
                qDebug() << "Paused";
                emit onPaused(); break;
            }
        }
        switch (mode) {
        case STOP: break;
        case PAUSE: break;
        case RUN:
            if (cnt > 0) cnt--;
            emit progressUpdate(anim.getCurrentTime() + (curframelen - cnt));
            if (cnt <= 0)
            {
                if (anim.eof())
                {
                    mode = STOP;
                    nextmode = mode;
                    anim.seek(0);
                    emit onStopped();
                    break;
                }
                else if (spisender.canSend())
                {
                    MxFrame nextframe = anim.nextFrame();
                    cnt = nextframe.length;
                    curframelen = nextframe.length;
                    spisender.sendFrame(SpiFrame(nextframe));
                    emit updateFrame(nextframe);
                }
            }
            break;
        }
        usleep(1000);
    }
    qDebug() << "KÖRTE";
    emit resultReady("ALMA");
}

AnimHandler::AnimHandler() : QThread(), spisender(26)
{
}

void AnimHandler::openFile(const std::string filepath) {
    nextmode = Mode::STOP;
    anim.openFile(filepath);
    emit onFileOpened(filepath);
    MxFrame empty;
    emit updateFrame(empty);
}

uint32_t AnimHandler::getAnimTimeLen() const
{
    return anim.getTimeLength();
}



