#ifndef FILEBROWSER_H
#define FILEBROWSER_H

#include <QWidget>
#include <QPushButton>
#include <QListWidget>
#include <QScrollArea>
#include <QVBoxLayout>
#include <vector>
#include <string>

class FileBrowser : public QWidget
{
    Q_OBJECT
private:
    std::vector<QPushButton*> buttons;
    QScrollArea* scrollArea;
    QListWidget* listWidget;
    QVBoxLayout* layout;
    std::string path;
    std::string lastpath;
    std::string namefilter;
    bool canCd(std::string path) const;
    std::string getCdUp() const;

public:
    std::vector<std::string> allowedFolders;

    FileBrowser( QWidget *parent = nullptr);
    ~FileBrowser();
    void update();
    void setPath(std::string newpath);
    const std::string getPath();
    std::vector<std::string> getFiles(std::string dir);
    std::vector<std::string> getDirs(std::string dir);

public slots:
    void backClicked();
    void dirClicked();
    void fileClicked();

signals:
    void fileSelected(const std::string filepath);
};

#endif // FILEBROWSER_H


