
#include <stdio.h>
#include <errno.h>
#include <wiringPiSPI.h>
#include <unistd.h>
#include <stdint.h>

using namespace std;

// channel is the wiringPi name for the chip select (or chip enable) pin.
// Set this to 0 or 1, depending on how it's connected.
static const int CHANNEL = 0;
static const int LED_NUM = 64;


int main(int argc, char** argv)
{
   int fd, result;
   uint16_t buffer[LED_NUM * 24+1] = {0};
   uint8_t dummy[2] = {70, 80};
//   wiringPiSPIDataRW(CHANNEL, dummy, 2);

//   wiringPiSPIDataRW(CHANNEL, (unsigned char*)dummy, 2);
        for(int i = 0; i < LED_NUM*24; i++)
        {
                if (argc > 1 && i % 24 == 5)
                buffer[i] = 0xFFFF;
        }

   printf("Initializing\n");

   // Configure the interface.
   // CHANNEL insicates chip select,
   // 500000 indicates bus speed.
   fd = wiringPiSPISetup(CHANNEL, 1800000);

   printf("Init result: %d\n", fd);

   if (argc > 2)
   {
      wiringPiSPIDataRW(CHANNEL, (unsigned char*)dummy, 1);
      printf("dummyend\n");
      sleep(1);
   }
   wiringPiSPIDataRW(CHANNEL, (unsigned char*)buffer, LED_NUM*24*2);
   wiringPiSPIDataRW(CHANNEL, (unsigned char*)dummy, 1);
   printf("Done\n");
   close(fd);
}