#include "animation.h"
#include "mxframe.h"
#include "spiframe.h"
#include "spisender.h"
#include "color.hpp"
#include "matrix_server.h"
#include "ola_receiver.h"
#include <unistd.h>
#include <stdio.h>
#include <string>
#include <poll.h>

int main()
{
    printf("Started\n");
    SpiSender spisender;
    MatrixServer matrixserver;
    ola_init(&spisender);
    printf("Going idle\n");
    while (1)
    {
        struct pollfd mypoll = {STDIN_FILENO, POLLIN | POLLPRI};
        ola_run_once();
        if (matrixserver.receive())
        {
            spisender.updateFrame(matrixserver.getFrame());
        }
        // if (poll(&mypoll, 1, 0))
        // {
        //     break;
        // }
    }

    printf("Ending\n");
    ola_deinit();
}
